#include "stdafx.h"
#include "CTest.h"

enum
{
	CMD_QUIT = 0,
	CMD_MESSAGEBOX = 1,
	CMD_RESTART = 2
};


/*
======================================
Constructor/Destructor
======================================
*/
CTest::CTest() : m_cvPlayerName("name", "John Doe", CVAR_STRING, CVAR_ARCHIVE),
				 m_cvPlayerAge("age","35", CVAR_INT, CVAR_ARCHIVE),
				 m_cvAlive("alive", "1", CVAR_BOOL, CVAR_READONLY |CVAR_ARCHIVE),
				 m_cvMhz("mhz", "450.0", CVAR_FLOAT, CVAR_LATCH | CVAR_ARCHIVE),
				 m_cvFree("myvar","1", CVAR_INT, 0)
{

	GetConsole()->RegisterCVar(&m_cvPlayerName,this);
	GetConsole()->RegisterCVar(&m_cvPlayerAge,this);
	GetConsole()->RegisterCVar(&m_cvMhz,this);
	GetConsole()->RegisterCVar(&m_cvAlive);
	GetConsole()->RegisterCVar(&m_cvFree);

	GetConsole()->RegisterCommand("quit",CMD_QUIT,this);
	GetConsole()->RegisterCommand("exit",CMD_QUIT,this);
	GetConsole()->RegisterCommand("restart",CMD_RESTART,this);
	GetConsole()->RegisterCommand("mbox",CMD_MESSAGEBOX,this);
}

CTest::~CTest()
{
}


/*
======================================
Handle commands
======================================
*/
void CTest::HandleCommand(HCMD cmdId, const CParms &parms)
{
	switch(cmdId)
	{
	case CMD_QUIT:
		AfxGetMainWnd()->PostMessage(WM_QUIT);
		break;
	case CMD_MESSAGEBOX:
		AfxMessageBox(parms.String());
		break;
	case CMD_RESTART:
		m_cvMhz.Unlatch();
		break;
	}
}

/*
======================================
Perform any validation here
======================================
*/
bool CTest::HandleCVar(const CVarBase * cvar, const CParms &parms)
{
	if(cvar == reinterpret_cast<CVarBase *>(&m_cvPlayerAge))
	{
		if(parms.NumTokens() > 1)
		{
			int age = parms.IntTok(1);
			if(age > 10 && age < 40)
				return true;
			ComPrintf("Invalid value for age\n");
		}
	}
	else if(cvar == reinterpret_cast<CVarBase *>(&m_cvMhz))
	{
		if(parms.NumTokens() > 1)
		{
			int mhz = parms.IntTok(1);
			if(mhz > 20 && mhz < 1000)
				return true;
			ComPrintf("Invalid Mhz\n");
		}
	}
	else if(cvar == reinterpret_cast<CVarBase *>(&m_cvPlayerName))
	{
		//add validation ?
		return true;
	}
	return false;
}

